module(... or "", package.seeall)

require('unix')
webots = false;
local cwd = unix.getcwd();
-- the webots sim is run from the WebotsController dir (not Player)
if string.find(cwd, "WebotsController") then
  webots = true;
  cwd = cwd.."/Player"
  package.path = cwd.."/?.lua;"..package.path;
end

computer = os.getenv('COMPUTER') or "";
if (string.find(computer, "Darwin")) then
   -- MacOS X uses .dylib:
   package.cpath = cwd.."/Lib/?.dylib;"..package.cpath;
else
   package.cpath = cwd.."/Lib/?.so;"..package.cpath;
end

package.path = cwd.."/Util/?.lua;"..package.path;
package.path = cwd.."/Config/?.lua;"..package.path;
package.path = cwd.."/Lib/?.lua;"..package.path;
package.path = cwd.."/Dev/?.lua;"..package.path;
package.path = cwd.."/Motion/?.lua;"..package.path;
package.path = cwd.."/Vision/?.lua;"..package.path;
package.path = cwd.."/World/?.lua;"..package.path;
package.path = cwd.."/BodyFSM/?.lua;"..package.path;
package.path = cwd.."/HeadFSM/?.lua;"..package.path;

require('vector')
require('Body')
require('keyframe')
print("test keyframe file name:");
keyin=io.stdin:read()

keyframe.load_motion_file(keyin,'standupFront');
tDelay = 0.020;
Body.set_actuator_hardness(vector.ones(20)*0.5);
Body.set_actuator_hardness(vector.ones(20)*1);

keyframe.entry();

t0 = unix.time();
keyframe.do_motion('standupFront');
loop=true;
while (loop) do
   keyframe.update();
   if (keyframe.get_queue_len()==0) then loop=false;end
   unix.usleep(1E6*tDelay);
end

Body.set_actuator_hardness(vector.ones(20)*0);

